#include "StdAfx.h"
#include "BmpUtil.h"

IMPLEMENT_DYNCREATE(CBmpUtil, CView)

CBmpUtil::CBmpUtil()
{
	m_crText = RGB(0, 0, 0);
	m_pBmpFont = NULL;
    m_nWidth = 0;
    m_nHeight = 0;
    m_nSliceWidth = 0;
}

CBmpUtil::~CBmpUtil()
{
    m_pBmpFont = NULL;  //1540(lint)
}

BEGIN_MESSAGE_MAP(CBmpUtil, CView)

END_MESSAGE_MAP()

void CBmpUtil::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();

}

void CBmpUtil::LoadUnitedBitmap(CString strFileName)
{
	m_picImg.Load(strFileName);

	m_nWidth		= m_picImg.m_Width;
	m_nHeight		= m_picImg.m_Height;
	m_nSliceWidth	= m_nWidth / 4;
}

void CBmpUtil::Draw(CDC* pDC, int nSeq, int nX, int nY, UINT nMask, CString strText)
{
	if (!pDC)
		return;

	UINT BLACK			= RGB(0, 0, 0);
	UINT WHITE			= RGB(255, 255, 255);
	UINT BMPWIDTH		= m_nWidth;
	UINT BMPHEIGHT		= m_nHeight;
	UINT MASK			= nMask;
	UINT SLICEWIDTH		= m_nSliceWidth;
	UINT INTERVAL		= SLICEWIDTH * nSeq;

	CDC					oriDC;
	CDC					srcDC;
	CDC					maskDC;
	CDC					memDC;
	CBitmap				oriBmp;
	CBitmap				srcBmp;
	CBitmap				maskBmp;	
	CBitmap				memBmp;
	CBitmap				*pOldoriDC = NULL;
	CBitmap				*pOldsrcDC = NULL;
	CBitmap				*pOldmaskDC = NULL;
	CBitmap				*pOldmemDC = NULL;

	oriDC.CreateCompatibleDC(pDC);
	oriBmp.CreateCompatibleBitmap(pDC, m_nWidth, m_nHeight);
	pOldoriDC = oriDC.SelectObject(&oriBmp);
	m_picImg.Show(&oriDC, CRect(0, 0, m_nWidth, m_nHeight));
	
	srcDC.CreateCompatibleDC(pDC);
	srcBmp.CreateCompatibleBitmap(pDC, SLICEWIDTH, BMPHEIGHT);
	pOldsrcDC = srcDC.SelectObject(&srcBmp);
	srcDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, &oriDC, INTERVAL, 0, SRCCOPY);
	
	maskDC.CreateCompatibleDC(pDC);
	maskBmp.CreateBitmap(SLICEWIDTH, BMPHEIGHT, 1, 1, NULL);
	pOldmaskDC = maskDC.SelectObject(&maskBmp);
	srcDC.SetBkColor(MASK);
	maskDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, &srcDC, 0, 0, SRCCOPY);

	srcDC.SetBkColor(BLACK);
	srcDC.SetTextColor(WHITE);
	srcDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, &maskDC, 0, 0, SRCAND);

	memDC.CreateCompatibleDC(pDC);
	memBmp.CreateCompatibleBitmap(pDC, SLICEWIDTH, BMPHEIGHT);
	pOldmemDC = memDC.SelectObject(&memBmp);

	memDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, pDC, nX, nY, SRCCOPY);
	memDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, &maskDC, 0, 0, SRCAND);		
	memDC.BitBlt(0, 0, SLICEWIDTH, BMPHEIGHT, &srcDC, 0, 0, SRCPAINT);

	if (!strText.IsEmpty())
	{
		CFont* pOldFont = NULL;
		if (m_pBmpFont)
			pOldFont = memDC.SelectObject(m_pBmpFont);
		CRect rtText(0, 0, SLICEWIDTH, BMPHEIGHT);
		memDC.SetBkMode(TRANSPARENT);
		memDC.SetTextColor(m_crText);
		memDC.DrawText(strText, &rtText, DT_CENTER | DT_VCENTER | DT_SINGLELINE|DT_NOPREFIX);

		if (pOldFont)
			memDC.SelectObject(pOldFont);
	}
	
	pDC->BitBlt(nX, nY, SLICEWIDTH, BMPHEIGHT, &memDC, 0, 0, SRCCOPY);

	oriDC.SelectObject(pOldoriDC);
	srcDC.SelectObject(pOldsrcDC);
	maskDC.SelectObject(pOldmaskDC);
	memDC.SelectObject(pOldmemDC);
}